<?php
/**
 * AstonishMe Protected Blogs Plugin
 *
 * @copyright (c)2008 by AstonishMe - {@link http://astonishme.co.uk/}.
 *
 * {@internal Below is a list of authors who have contributed to design/coding of this file: }}
 * @author Yabba	- {@link http://www.astonishme.co.uk/}
 * @author Stk		- {@link http://www.astonishme.co.uk/}
 *
 * @license GNU General Public License 2 (GPL) - http://www.opensource.org/licenses/gpl-license.php
 *
 */

if( !defined('EVO_MAIN_INIT') ) die( 'Please, do not access this page directly.' );

class am_protectedblogs_plugin extends Plugin
{
	var $name = 'AM Protected Blogs';
	var $code = 'am_protect';
	var $priority = 100;
	var $version = '1.0';
	var $author = 'AstonishMe';
	var $group = 'AstonishMe';

	var $apply_rendering = 'never';

	function PluginInit()
	{
		$this->short_desc = $this->T_( 'Make your blogs visible to members only' );
	}

	function GetDefaultSettings()
	{
		$r = array(
			'login_message' => array(
				'label' => $this->T_('Message'),
				'defaultvalue' => '',
				'note' => $this->T_('Message to display when login required'),
				'type' => 'text',
				'defaultvalue' => $this->T_('You need to be a registered member to view that blog' ),
			),			);
		return $r;
	}


	/**
	 * Checks if blog is protected
	 *
	 * If protected checks if visitor/user is a blog member
	 * Redirects to login screen or homepage if protected
	 *
	 */
  function BeforeBlogDisplay()
  {
  	global $Messages, $Blog, $current_User, $baseurl;

  	if( !empty( $Blog ) && preg_match( '~am:protect~i', $Blog->get( 'notes' ) ) )
  	{ // this is a protected blog
	  	if( !is_logged_in() || !$current_User->check_perm( 'blog_ismember', 'any', false, $Blog->ID ) )
	  	{ // user/vistor is not a blog member
				$Messages->add( $this->Settings->get( 'login_message' ), 'error' );
				$redirect_to = ( is_logged_in() ? $baseurl : get_login_url() ); // send users back to homepage, visitors get a chance to login
				header_nocache();
				// redirect Will save $Messages into Session:
				header_redirect( $redirect_to ); // display login screen or home page if already logged in
	  	}
  	}
  }


  /**
   * Checks if this is a protected blog
   * If so changes any pubslished posts to protected
   *
   * @param mixed array $params
   */
  function AdminBeforeItemEditCreate( $params = array() )
  {
  	if( preg_match( '~am:protect~i', $params['Item']->Blog->get( 'notes' ) ) && $params['Item']->get( 'status' ) == 'published' )
  	{ // this is a protected blog, public posts not allowed
  		$params['Item']->set( 'status', 'protected' );
  		global $Messages;
  		$Messages->add( $this->T_( 'Post status changed to protected' ), 'success' );
  	}
  }


  /**
   * Does exactly the same when editing posts ;)
   */
  function AdminBeforeItemEditUpdate( $params = array() )
  {
  	$this->AdminBeforeItemEditCreate( $params );
  }
}
?>